"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Q {
    constructor(sobject) {
        this.select = (fields) => {
            this.fieldList.push.apply(this.fieldList, fields);
            return this;
        };
        this.limit = (limit) => {
            this.numberOfRows = limit;
            return this;
        };
        this.where = (field, operator, value) => {
            this.conditions.push({
                field,
                operator,
                value,
            });
            return this;
        };
        this.buildSelect = () => {
            if (this.fieldList.length !== 0) {
                return 'SELECT ' + this.fieldList.join(', ');
            }
            else {
                return 'SELECT Id';
            }
        };
        this.buildConditions = () => {
            const condList = [];
            this.conditions.map(({ field, operator, value }) => {
                condList.push(`${field} ${operator} '${value}'`);
            });
            if (this.conditions.length !== 0) {
                return 'WHERE ' + condList.join(' AND ');
            }
            else {
                return null;
            }
        };
        this.build = () => {
            const queryParts = [];
            queryParts.push(this.buildSelect());
            queryParts.push('FROM ' + this.fromText);
            if (this.conditions.length !== 0) {
                queryParts.push(this.buildConditions());
            }
            if (this.numberOfRows) {
                queryParts.push('LIMIT ' + this.numberOfRows);
            }
            return queryParts.join(' ');
        };
        this.fromText = sobject;
        this.fieldList = [];
        this.conditions = [];
    }
}
exports.default = Q;
