const jsforce = require("jsforce");

const conn = new jsforce.Connection({});

const types = {
  'id': 'ID!',
  'boolean': 'Boolean',
  'reference': 'String', // TODO: Make relationship
  'string': 'String',
  'picklist': 'String', // TODO: make ENUM
  'textarea': 'String',
  'double': 'Int', // TODO: is this accurate?
  'address': 'String',
  'email': 'String',
  'phone': 'String',
  'url': 'String',
  'currency': 'Int', // TODO: is this accurate?
  'int': 'Int', // TODO: is this accurate?
  'datetime': 'String', // TODO: is this accurate?
  'date': 'String', // TODO: is this accurate?
}

const graphqlTypes = {};

conn.login("contact@jpmonette.net", "cc2QgHOsfsf", function(err, userInfo) {
  const objectLabel = 'Contact'
  conn.describe(objectLabel, (err, res) => {
    graphqlTypes[objectLabel] = {references: [], fields: []};
    // console.log(res.fields)
    res.fields.map((result, index) => {
      const { name, type } = result;
      // if (name === 'AccountId')console.log(result)
      if (type === 'reference') {
        const relName = name.indexOf('__c') !== -1 ? name.replace('__c', '__r') : name.slice(0, name.length - 2)
        graphqlTypes[objectLabel].fields.push([relName, result.referenceTo[0]])
        graphqlTypes[objectLabel].references.push([name, result.referenceTo[0]])
      }
      graphqlTypes[objectLabel].fields.push([name, (types[type] ? types[type] :  '##### ' + type)])
    })
    // res.sobjects.map((value, index) => {
    //   const {queryable, createable, triggerable, searchable, retrieveable, deletable } = value;
    //   if (queryable && createable && deletable && retrieveable && searchable && triggerable)
    //     console.log(value.name, value.labelPlural, value)
    // })
    console.log(graphqlTypes['Contact']);
  })
});

